Loading...
Searching...
No Matches
casacore::StManColumnAipsIO Class Reference
tables package (libcasa_tables) » DataMan_module » DataMan_module_internal_classes

More...

`#include <StManAipsIO.h>`

## Public Member Functions

| StManColumnAipsIO (StManAipsIO *stMan, int dataType, Bool byPtr)
| Create a column of the given type.
virtual | ~StManColumnAipsIO ()
| Frees up the storage.
| StManColumnAipsIO (const StManColumnAipsIO &)=delete
| Forbid copy constructor.
StManColumnAipsIO & | operator= (const StManColumnAipsIO &)=delete
| Forbid assignment.
virtual void | putFile (rownr_t nrval, AipsIO &)
| Write the column data into AipsIO.
virtual void | getFile (rownr_t nrval, AipsIO &)
| Read the column data from AipsIO.
Public Member Functions inherited from casacore::MSMColumn
| MSMColumn (MSMBase *smptr, int dataType, Bool byPtr)
| Create a column of the given type.
virtual | ~MSMColumn ()
| Frees up the storage.
| MSMColumn (const MSMColumn &)=delete
| Forbid copy constructor.
MSMColumn & | operator= (const MSMColumn &)=delete
| Forbid assignment.
virtual void | getBool (rownr_t rownr, Bool *dataPtr)
| Get a scalar value in the given row.
virtual void | getuChar (rownr_t rownr, uChar *dataPtr)
virtual void | getShort (rownr_t rownr, Short *dataPtr)
virtual void | getuShort (rownr_t rownr, uShort *dataPtr)
virtual void | getInt (rownr_t rownr, Int *dataPtr)
virtual void | getuInt (rownr_t rownr, uInt *dataPtr)
virtual void | getInt64 (rownr_t rownr, Int64 *dataPtr)
virtual void | getfloat (rownr_t rownr, float *dataPtr)
virtual void | getdouble (rownr_t rownr, double *dataPtr)
virtual void | getComplex (rownr_t rownr, Complex *dataPtr)
virtual void | getDComplex (rownr_t rownr, DComplex *dataPtr)
virtual void | getString (rownr_t rownr, String *dataPtr)
virtual void | putBool (rownr_t rownr, const Bool *dataPtr)
| Put a scalar value into the given row.
virtual void | putuChar (rownr_t rownr, const uChar *dataPtr)
virtual void | putShort (rownr_t rownr, const Short *dataPtr)
virtual void | putuShort (rownr_t rownr, const uShort *dataPtr)
virtual void | putInt (rownr_t rownr, const Int *dataPtr)
virtual void | putuInt (rownr_t rownr, const uInt *dataPtr)
virtual void | putInt64 (rownr_t rownr, const Int64 *dataPtr)
virtual void | putfloat (rownr_t rownr, const float *dataPtr)
virtual void | putdouble (rownr_t rownr, const double *dataPtr)
virtual void | putComplex (rownr_t rownr, const Complex *dataPtr)
virtual void | putDComplex (rownr_t rownr, const DComplex *dataPtr)
virtual void | putString (rownr_t rownr, const String *dataPtr)
virtual void | getScalarColumnV (ArrayBase &data)
| Get all scalar values in the column.
virtual void | putScalarColumnV (const ArrayBase &data)
| Put all scalar values in the column.
virtual void | addRow (rownr_t newNrrow, rownr_t oldNrrow)
| Add (newNrrow-oldNrrow) rows to the column.
void | resize (rownr_t nrval)
| Resize the data blocks.
virtual void | remove (rownr_t rownr)
| Remove the given row.
virtual void | doCreate (rownr_t nrrow)
| Create the number of rows in a new table.
virtual void | reopenRW ()
| Reopen the storage manager files for read/write.
virtual Bool | ok () const
| Check if the class invariants still hold.
Public Member Functions inherited from casacore::StManColumnBase
| StManColumnBase (int dataType)
| Default constructor.
| ~StManColumnBase ()
| StManColumnBase (const StManColumnBase &)=delete
| The object cannot be copied.
StManColumnBase & | operator= (const StManColumnBase &)=delete
| The object cannot be assigned to.
virtual int | dataType () const
| Return the data type of the column.
DataType | dtype () const
Int | elemSize () const
| Return the size of an element of the column's data type.
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual String | dataTypeId () const
| Get the data type id of the column for dataType==TpOther.
virtual Bool | isWritable () const
| Test if data can be put into this column.
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of the value (can be used for strings).
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of an (variable-shaped) array in the given row.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual Bool | isShapeDefined (rownr_t rownr)
| Is the value shape defined in the given row?
virtual uInt | ndim (rownr_t rownr)
| Get the dimensionality of the item in the given row.
virtual IPosition | shape (rownr_t rownr)
| Get the shape of the item in the given row.
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
virtual Bool | canChangeShape () const
| Can the data manager handle chaging the shape of an existing array?
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr)
| Get some scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some scalar values in the column.
virtual void | getArrayV (rownr_t rownr, ArrayBase &dataPtr)
| Get the array value in the given row.
virtual void | putArrayV (rownr_t rownr, const ArrayBase &data)
| Put the array value into the given row.
virtual void | getArrayColumnV (ArrayBase &data)
| Get all array values in the column.
virtual void | putArrayColumnV (const ArrayBase &data)
| Put all array values in the column.
virtual void | getArrayColumnCellsV (const RefRows &rownrs, ArrayBase &data)
| Get some array values in the column.
virtual void | putArrayColumnCellsV (const RefRows &rownrs, const ArrayBase &data)
| Put some array values in the column.
virtual void | getSliceV (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
| Get a section of the array in the given row.
virtual void | putSliceV (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
| Put into a section of the array in the given row.
virtual void | getColumnSliceV (const Slicer &slicer, ArrayBase &data)
| Get a section of all arrays in the column.
virtual void | putColumnSliceV (const Slicer &slicer, const ArrayBase &data)
| Put into a section of all arrays in the column.
virtual void | getColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
| Get a section of some arrays in the column.
virtual void | putColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)
| Put into a section of some arrays in the column.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Protected Member Functions

virtual void | initData (void *datap, rownr_t nrval)
| initData does not do anything (only used in MSMColumn).
virtual void | putData (void *datap, uInt nrval, AipsIO &)
| Put the data (nrval elements) in an extension (starting at datap) into AipsIO.
virtual void | getData (void *datap, uInt index, uInt nrval, AipsIO &, uInt version)
| Get data (nrval elements) into an extension (starting at datap plus the given index).
Protected Member Functions inherited from casacore::MSMColumn
uInt | findExt (rownr_t rownr, Bool setCache)
| Find the extension in which the row number is.
void * | allocData (rownr_t nrval, Bool byPtr)
| Allocate an extension with the data type of the column.
void | deleteAll ()
| Delete all extensions.
void | deleteData (void *datap, Bool byPtr)
| Delete an extension.
void | removeData (void *datap, rownr_t inx, rownr_t nrvalAfter)
| Remove an entry (i.e.
void * | getArrayPtr (rownr_t rownr)
| Get the pointer for the given row.
void | putArrayPtr (rownr_t rownr, void *dataPtr)
| Put the pointer for the given row.
Protected Member Functions inherited from casacore::DataManagerColumn
virtual void | getOther (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)

## Additional Inherited Members

Static Public Member Functions inherited from casacore::StManColumnBase
static Bool | isNativeDataType (int dtype)
| Test if the given data type is supported by storage managers.
Protected Attributes inherited from casacore::MSMColumn
MSMBase * | stmanPtr_p
Bool | byPtr_p
| The data is indirectly accessed via a pointer (for the derived classes).
rownr_t | nralloc_p
| The number of allocated rows in the column.
uInt | nrext_p
| The nr of extensions in use.
Block< void * > | data_p
| The assembly of all extensions (actually Block<T*>).
Block< rownr_t > | ncum_p
| The cumulative nr of rows in all extensions.

## Detailed Description

AipsIO table column storage manager class

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- DataManagerColumn

### Etymology

StManColumnAipsIO handles a column for an AipsIO storage manager.

### Synopsis

StManColumnAipsIO is used by StManAipsIO to handle the access to the data in a table column. It is an storage manager based on AipsIO. The entire column is kept in memory and only written when the storage manager closes. When the storage manager gets opened, the entire column gets read back. It fully supports addition and removal of rows.

StManColumnAipsIO serves 2 purposes:

1. It handles a column containing scalar values.
2. It serves as a base class for StManArrayColumnAipsIO and StManIndArrayColumnAipsIO. These classes handle arrays and use StManColumnAipsIO to hold a pointer to the array in each row.

StManColumnAipsIO does not hold a column as a consecutive array, because extending the column (i.e. adding rows) proofed be too expensive due to the repeated copying involved when creating a table (this method was used by the old table system). Instead it has a number of data blocks (extensions) indexed to by a super block. Accessing a row means finding the appropriate extension via a binary search. Because there is only 1 extension when a table is read back, the overhead in finding a row is small.

### Motivation

StManColumnAipsIO handles the standard data types. The class is not templated, but a switch statement is used instead. Templates would cause too many instantiations.

Definition at line 105 of file StManAipsIO.h.

## Constructor & Destructor Documentation

## StManColumnAipsIO() [1/2]

casacore::StManColumnAipsIO::StManColumnAipsIO | ( | StManAipsIO * | stMan,
|  | int | dataType,
|  | Bool | byPtr )

Create a column of the given type.

It will maintain a pointer to its parent storage manager.

References casacore::dataType().

Referenced by operator=(), and StManColumnAipsIO().

## ~StManColumnAipsIO()

virtual casacore::StManColumnAipsIO::~StManColumnAipsIO | ( |  | ) |

virtual

Frees up the storage.

## StManColumnAipsIO() [2/2]

casacore::StManColumnAipsIO::StManColumnAipsIO | ( | const StManColumnAipsIO & |  | ) |

delete

Forbid copy constructor.

References StManColumnAipsIO().

## Member Function Documentation

## getData()

virtual void casacore::StManColumnAipsIO::getData | ( | void * | datap,
|  | uInt | index,
|  | uInt | nrval,
|  | AipsIO & | ,
|  | uInt | version )

protected virtual

Get data (nrval elements) into an extension (starting at datap plus the given index).

Reimplemented in casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

## getFile()

virtual void casacore::StManColumnAipsIO::getFile | ( | rownr_t | nrval,
|  | AipsIO & | )

virtual

Read the column data from AipsIO.

One extension gets allocated to hold all rows in the column.

Reimplemented from casacore::MSMColumn.

Reimplemented in casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

## initData()

virtual void casacore::StManColumnAipsIO::initData | ( | void * | datap,
|  | rownr_t | nrval )

protected virtual

initData does not do anything (only used in MSMColumn).

Reimplemented from casacore::MSMColumn.

## operator=()

StManColumnAipsIO & casacore::StManColumnAipsIO::operator= | ( | const StManColumnAipsIO & |  | ) |

delete

Forbid assignment.

References StManColumnAipsIO().

## putData()

virtual void casacore::StManColumnAipsIO::putData | ( | void * | datap,
|  | uInt | nrval,
|  | AipsIO & | )

protected virtual

Put the data (nrval elements) in an extension (starting at datap) into AipsIO.

Reimplemented in casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

## putFile()

virtual void casacore::StManColumnAipsIO::putFile | ( | rownr_t | nrval,
|  | AipsIO & | )

virtual

Write the column data into AipsIO.

It will successively write all extensions using putData.

Reimplemented from casacore::MSMColumn.

Reimplemented in casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

The documentation for this class was generated from the following file:

- tables/DataMan/StManAipsIO.h